/// <reference types="node" />
import { SimplePublisherInterface } from "ts-simple-interfaces";
import { EventEmitter } from "events";
interface MethodCall {
    method: string;
    args: any[];
}
export declare class MockSimplePublisher implements SimplePublisherInterface<unknown, unknown> {
    protected emitter: EventEmitter;
    protected _calls: MethodCall[];
    constructor();
    publish(channel: string, routingKey: string, event: unknown, options?: unknown, ...rest: any[]): Promise<void>;
    close(...rest: any[]): Promise<void>;
    on(event: "error", listener: (e: Error) => void): this;
    on(event: "connect", listener: () => void): this;
    on(event: "disconnect", listener: () => void): this;
    once(event: "error", listener: (e: Error) => void): this;
    once(event: "connect", listener: () => void): this;
    once(event: "disconnect", listener: () => void): this;
    removeListener(event: "connect" | "disconnect" | "error", listener: () => void): this;
    removeAllListeners(event?: "connect" | "disconnect" | "error"): this;
    get calls(): any[];
    protected register(method: string, args: any[]): void;
}
export {};
