"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockSimplePublisher = void 0;
const events_1 = require("events");
class MockSimplePublisher {
    constructor() {
        this._calls = [];
        this.emitter = new events_1.EventEmitter();
    }
    publish(channel, routingKey, event, options, ...rest) {
        const t = this;
        return new Promise(function (resolve, reject) {
            t.register("publish", [channel, routingKey, event, options].concat(rest));
            resolve();
        });
    }
    close(...rest) {
        return __awaiter(this, void 0, void 0, function* () {
            this.register("close", rest);
        });
    }
    on(event, listener) {
        this.emitter.on(event, listener);
        return this;
    }
    once(event, listener) {
        this.emitter.once(event, listener);
        return this;
    }
    removeListener(event, listener) {
        this.emitter.removeListener(event, listener);
        return this;
    }
    removeAllListeners(event) {
        this.emitter.removeAllListeners(event);
        return this;
    }
    get calls() {
        return this._calls;
    }
    register(method, args) {
        this._calls.push({ method, args });
    }
}
exports.MockSimplePublisher = MockSimplePublisher;
