/// <reference types="node" />
import { SimpleSqlDbInterface, SimpleSqlResponseInterface, SqlValue } from "ts-simple-interfaces";
interface MockDbConfig {
    throwOnClose: boolean;
}
export declare const md5: (str: string) => string;
export declare class MockSimpleSqlDb implements SimpleSqlDbInterface {
    protected closed: boolean;
    protected config: MockDbConfig;
    protected queryMockResultQueue: {
        [hash: string]: Array<SimpleSqlResponseInterface<any> | NodeJS.ErrnoException>;
    };
    constructor(config?: Partial<MockDbConfig>);
    /**
     * If an exception is passed, it is thrown when the query is called. Otherwise, the given response is returned
     */
    setQueryResult(hashOrQuery: string, result: SimpleSqlResponseInterface<any> | NodeJS.ErrnoException): void;
    query(query: string, params?: Array<SqlValue>): Promise<SimpleSqlResponseInterface<any>>;
    close(): void;
}
export {};
